Border and Gridlines

Spread allows you to set borders and diagonal border line for cells. You can show or hide the sheet gridlines.

The demo is being dynamically compiled to support real-time code editing... For quicker access to features, switch to the "JavaScript" tab for a smoother experience! :)
Description
app.js
index.html
styles.css
Copy to CodeMine

Spread provides several types of line styles to help you customize the sheet's border line and grid lines, such as thin, dotted, double, and so on. For example, the following lines change the left and right border lines of the indicated range to the dotted line style.

    var lineStyle = GC.Spread.Sheets.LineStyle.dotted;
    var lineBorder = new GC.Spread.Sheets.LineBorder('red', lineStyle);
    var sheetArea = GC.Spread.Sheets.SheetArea.viewport;
    sheet.getRange(1, 1, 1, 1).setBorder(lineBorder, { left: true, right: true}, sheetArea);

Spread provides two kinds of diagonal border line. The diagonal border line includes diagonal down and diagonal up.

For example,The following set the diagonal border line for cells

    sheet.getCell(1, 1).diagonalDown(new GC.Spread.Sheets.LineBorder('blue',GC.Spread.Sheets.LineStyle.double));
    sheet.getCell(1, 1).diagonalUp(new GC.Spread.Sheets.LineBorder('blue',GC.Spread.Sheets.LineStyle.double));

You can add or remove gridlines or set the color with the following code:

    sheet.options.gridline = {color:"#FF2235", showVerticalGridline: false, showHorizontalGridline: true};

You can set the option SheetAreaOffset to move the whole sheet rendering area have some offset from the host left/top point.There will be enough space to show all things (just like left/top border and left/top selection) perfectly.

    sheet.options.sheetAreaOffset= {left : 2, top : 2};

The sheetAreaOffset default value is {left:0,top:0}.

Spread provides several types of line styles to help you customize the sheet's border line and grid lines, such as thin, dotted, double, and so on. For example, the following lines change the left and right border lines of the indicated range to the dotted line style. Spread provides two kinds of diagonal border line. The diagonal border line includes diagonal down and diagonal up. diagonalDown diagonalUp For example,The following set the diagonal border line for cells You can add or remove gridlines or set the color with the following code: You can set the option SheetAreaOffset to move the whole sheet rendering area have some offset from the host left/top point.There will be enough space to show all things (just like left/top border and left/top selection) perfectly. The sheetAreaOffset default value is {left:0,top:0}.
var spreadNS = GC.Spread.Sheets; window.onload = function() { var spread = new GC.Spread.Sheets.Workbook(_getElementById('ss'), { sheetCount: 2 }); var sheet = spread.getSheet(0); sheet.suspendPaint(); sheet.options.gridline.showHorizontalGridline = false; sheet.options.gridline.showVerticalGridline = false; var lineBorder1 = new spreadNS.LineBorder('blue', spreadNS.LineStyle.thin); var range = sheet.getRange(7, 1, 2, 2); range.setBorder(lineBorder1, { outline: true }); range.borderLeft(new spreadNS.LineBorder('red', spreadNS.LineStyle.double)); range = sheet.getRange(7, 4, 2, 2); range.setBorder(lineBorder1, { outline: true }); range.borderTop(new spreadNS.LineBorder('green', spreadNS.LineStyle.medium)); range = sheet.getRange(7, 7, 2, 2); range.setBorder(lineBorder1, { outline: true }); range.borderRight(new spreadNS.LineBorder('black', spreadNS.LineStyle.dashed)); range = sheet.getRange(7, 10, 2, 2); range.setBorder(lineBorder1, { outline: true }); range.borderBottom(new spreadNS.LineBorder('purple', spreadNS.LineStyle.dotted)); range = sheet.getRange(11, 1, 2, 2); range.setBorder(new spreadNS.LineBorder('orange', spreadNS.LineStyle.thick), { all: true }); range.diagonalUp(new spreadNS.LineBorder('orange', spreadNS.LineStyle.thin)); range = sheet.getRange(11, 4, 2, 2); range.setBorder(new spreadNS.LineBorder('orange', spreadNS.LineStyle.hair), { all: true }); range.diagonalDown(new spreadNS.LineBorder('purple', spreadNS.LineStyle.dotted)); range = sheet.getRange(11, 7, 2, 2); range.setBorder(new spreadNS.LineBorder('orange', spreadNS.LineStyle.mediumDashed), { all: true }); range.diagonalUp(new spreadNS.LineBorder('plum', spreadNS.LineStyle.double)); range.diagonalDown(new spreadNS.LineBorder('brown', spreadNS.LineStyle.thick)); range = sheet.getRange(11, 10, 2, 2); range.setBorder(new spreadNS.LineBorder('orange', spreadNS.LineStyle.dashDot), { all: true }); range = sheet.getRange(17, 1, 2, 5); range.setBorder(lineBorder1, { outline: true }); range = sheet.getRange(17, 1, 2, 2); range.setBorder(new spreadNS.LineBorder('brown', spreadNS.LineStyle.slantedDashDot), { inside: true }); range = sheet.getRange(17, 4, 2, 2); range.setBorder(new spreadNS.LineBorder('brown', spreadNS.LineStyle.mediumDashed), { inside: true }); range = sheet.getRange(16, 7, 7, 4); range.setBorder(new spreadNS.LineBorder('plum', spreadNS.LineStyle.thick), { left: true, bottom: true }); range = sheet.getRange(15, 8, 7, 4); range.setBorder(new spreadNS.LineBorder('royalblue', spreadNS.LineStyle.slantedDashDot), { top: true, right: true }); range = sheet.getRange(16, 8, 6, 3); range.setBorder(new spreadNS.LineBorder('tomato', spreadNS.LineStyle.dashDot), { left: true, bottom: true }); range = sheet.getRange(16, 8, 6, 3); range.setBorder(new spreadNS.LineBorder('palegreen', spreadNS.LineStyle.mediumDashed), { top: true, right: true }); range = sheet.getRange(16, 9, 5, 2); range.setBorder(new spreadNS.LineBorder('violet', spreadNS.LineStyle.dotted), { left: true, bottom: true }); range = sheet.getRange(17, 8, 5, 2); range.setBorder(new spreadNS.LineBorder('skyblue', spreadNS.LineStyle.hair), { top: true, right: true }); sheet.addSpan(17, 9, 2, 1); range = sheet.getRange(17, 9, 2, 1); range.setBorder(new spreadNS.LineBorder('purple', spreadNS.LineStyle.thin), { all: true }); addTableInfo(sheet); initSheetAreaSheet(spread.getSheet(1)); _getElementById('gridline_show').addEventListener('change', function() { var sheet = spread.getActiveSheet(); sheet.suspendPaint(); sheet.options.gridline.showHorizontalGridline = this.checked; sheet.options.gridline.showVerticalGridline = this.checked; sheet.resumePaint(); }); spread.bind(GC.Spread.Sheets.Events.ActiveSheetChanged, function(e, args) { if (args.oldSheet === sheet) { _forSheetAreaStatus('block'); _getElementByClassName('forBorder')[0].setAttribute('style', 'display:none'); } else { _forSheetAreaStatus('none'); _getElementByClassName('forBorder')[0].setAttribute('style', 'display:block'); } }); }; function addTableInfo(sheet) { sheet.setArray(1, 3, [ [ 'Gender', 'Phone Number', 'Address' ], [ 'woman', '021-432668', 'Chester Road' ], [ 'man', '021-432238', 'Gertt Road' ], [ 'man', '021-432533', 'Jnyliner Road' ], [ 'man', '021-432125', 'Approach Road' ] ]); var style = new GC.Spread.Sheets.Style(); style.wordWrap = true; style.vAlign = GC.Spread.Sheets.VerticalAlign.center; sheet.setStyle(1, 2, style, 3); sheet.setText(1, 2, ' Info Name', spreadNS.SheetArea.viewport); cell = sheet.getCell(1, 2); cell.diagonalDown(new spreadNS.LineBorder('purple', spreadNS.LineStyle.dotted)); sheet.setStyle(1, 3, style, GC.Spread.Sheets.SheetArea.viewport); sheet.setStyle(1, 4, style, GC.Spread.Sheets.SheetArea.viewport); sheet.setStyle(1, 5, style, GC.Spread.Sheets.SheetArea.viewport); sheet.setText(2, 2, 'John', spreadNS.SheetArea.viewport); sheet.setText(3, 2, 'linda', spreadNS.SheetArea.viewport); sheet.setText(4, 2, 'henry', spreadNS.SheetArea.viewport); sheet.setText(5, 2, 'smith', spreadNS.SheetArea.viewport); sheet.setRowHeight(1, 30); sheet.setColumnWidth(4, 120); sheet.setColumnWidth(5, 120); range = sheet.getRange(1, 2, 5, 4); range.setBorder(new spreadNS.LineBorder('black', spreadNS.LineStyle.thin), { all: true }); sheet.resumePaint(); } function initSheetAreaSheet(sheet) { sheet.suspendPaint(); sheet.name('SheetAreaOffset'); var data = sheetAreaJSON; sheet.fromJSON(data); sheet.options.colHeaderVisible = false; sheet.options.rowHeaderVisible = false; sheet.options.sheetAreaOffset = { left: 2, top: 2 }; var range = sheet.getRange(0, 0, 3, 10); range.setBorder(new spreadNS.LineBorder('black', spreadNS.LineStyle.double), { left: true, bottom: true, top: true, right: true }); sheet.resumePaint(); _getElementById('headerVisible').addEventListener('change', function() { sheet.options.rowHeaderVisible = this.checked; sheet.options.colHeaderVisible = this.checked; }); _getElementById('setOffset').addEventListener('click', function() { var left = _getElementById('offsetLeft').value, top = _getElementById('offsetTop').value; sheet.options.sheetAreaOffset = { left: parseInt(left, 10), top: parseInt(top, 10) }; }); _forSheetAreaStatus('none'); } function _getElementById(id) { return document.getElementById(id); } function _getElementByClassName(className) { return document.getElementsByClassName(className); } function _forSheetAreaStatus(status) { var forSheetAreas = _getElementByClassName('forSheetArea'); for (var i = 0; i < forSheetAreas.length; i++) { forSheetAreas[i].setAttribute('style', 'display:' + status); } }
<!doctype html> <html style="height:100%;font-size:14px;"> <head> <meta charset="utf-8" /> <meta name="viewport" content="width=device-width, initial-scale=1.0" /> <link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/purejs/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css"> <script src="$DEMOROOT$/en/purejs/node_modules/@mescius/spread-sheets/dist/gc.spread.sheets.all.min.js" type="text/javascript"></script> <script src="$DEMOROOT$/spread/source/js/license.js" type="text/javascript"></script> <script src="$DEMOROOT$/spread/source/data/sheetAreaData.js" type="text/javascript"></script> <script src="app.js" type="text/javascript"></script> <link rel="stylesheet" type="text/css" href="styles.css"> </head> <body> <div class="sample-tutorial"> <div id="ss" class="sample-spreadsheets"></div> <div class="options-container"> <div class="option-row forBorder"> <input type="checkbox" id="gridline_show"/> <label for="gridline_show" title="Set whether to display grid line">ShowGridLine</label> </div> <div class="option-row forSheetArea"> <input type="checkbox" id="headerVisible"><label for="headerVisible">HeaderVisible</label> </div> <div class="option-row forSheetArea"> <label> left: <input type="number" id="offsetLeft" value="2" /></label> </div> <div class="option-row forSheetArea"> <label> top: <input type="number" id="offsetTop" value="2" /></label> </div> <div class="option-row forSheetArea"> <input type="button" id="setOffset" value="Set Sheet Area Offset"> </div> </div> </div> </body> </html>
.sample-tutorial { position: relative; height: 100%; overflow: hidden; } .sample-spreadsheets { width: calc(100% - 300px); height: calc(100% - 20px); overflow: hidden; float: left; margin: 10px; } .options-container { float: right; width: 280px; padding: 12px; height: 100%; box-sizing: border-box; background: #fbfbfb; overflow: auto; } .option-row { font-size: 14px; padding: 5px; margin-top: 10px; } label { margin-bottom: 6px; } input { padding: 4px 6px; } input[type=button] { margin-top: 6px; display: block; } body { position: absolute; top: 0; bottom: 0; left: 0; right: 0; }

Spread provides several types of line styles to help you customize the sheet's border line and grid lines, such as thin, dotted, double, and so on. For example, the following lines change the left and right border lines of the indicated range to the dotted line style.
Spread provides two kinds of diagonal border line. The diagonal border line includes diagonal down and diagonal up.
diagonalDown
diagonalUp
For example,The following set the diagonal border line for cells
You can add or remove gridlines or set the color with the following code:
You can set the option SheetAreaOffset to move the whole sheet rendering area have some offset from the host left/top point.There will be enough space to show all things (just like left/top border and left/top selection) perfectly.
The sheetAreaOffset default value is {left:0,top:0}.
import { Component, NgModule, enableProdMode } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { FormsModule } from '@angular/forms';
import { platformBrowserDynamic } from '@angular/platform-browser-dynamic';
import { SpreadSheetsModule } from '@mescius/spread-sheets-angular';
import GC from '@mescius/spread-sheets';
import './styles.css';
const spreadNS = GC.Spread.Sheets, SheetArea = spreadNS.SheetArea;
@Component({
selector: 'app-component',
templateUrl: 'src/app.component.html'
})
export class AppComponent {
spread: GC.Spread.Sheets.Workbook;
isGridLinePanel:boolean;
left: number;
top: number;
showGridLine: boolean;
headerVisible: boolean;
hostStyle = {
width: 'calc(100% - 280px)',
height: '100%',
overflow: 'hidden',
float: 'left'
};
constructor() {
this.isGridLinePanel = true;
}
initSpread($event: any) {
let self = this;
let spread = this.spread = $event.spread;
spread.addSheet(1);
this.initSheetBorderAndGridLine();
this.initSheetAreaSheet();
let gridlineSheet = spread.getSheet(0);
self.showGridLine = gridlineSheet.options.gridline.showHorizontalGridline && gridlineSheet.options.gridline.showVerticalGridline;
spread.bind(GC.Spread.Sheets.Events.ActiveSheetChanged, function(e: any, args: any) {
let isGridLinePanel;
if (args.newSheet === gridlineSheet) {
isGridLinePanel = true;
} else {
isGridLinePanel = false;
}
self.isGridLinePanel = isGridLinePanel;
});
}
initSheetBorderAndGridLine() {
let spread = this.spread;
let sheet = spread.getSheet(0);
sheet.suspendPaint();
sheet.options.gridline.showHorizontalGridline = false;
sheet.options.gridline.showVerticalGridline = false;
let lineBorder1 = new spreadNS.LineBorder('blue', spreadNS.LineStyle.thin);
let range = sheet.getRange(7, 1, 2, 2);
range.setBorder(lineBorder1, { outline: true });
range.borderLeft(new spreadNS.LineBorder('red', spreadNS.LineStyle.double));
range = sheet.getRange(7, 4, 2, 2);
range.setBorder(lineBorder1, { outline: true });
range.borderTop(new spreadNS.LineBorder('green', spreadNS.LineStyle.medium));
range = sheet.getRange(7, 7, 2, 2);
range.setBorder(lineBorder1, { outline: true });
range.borderRight(new spreadNS.LineBorder('black', spreadNS.LineStyle.dashed));
range = sheet.getRange(7, 10, 2, 2);
range.setBorder(lineBorder1, { outline: true });
range.borderBottom(new spreadNS.LineBorder('purple', spreadNS.LineStyle.dotted));
range = sheet.getRange(11, 1, 2, 2);
range.setBorder(new spreadNS.LineBorder('orange', spreadNS.LineStyle.thick), { all: true });
range.diagonalUp(new spreadNS.LineBorder('orange', spreadNS.LineStyle.thin));
range = sheet.getRange(11, 4, 2, 2);
range.setBorder(new spreadNS.LineBorder('orange', spreadNS.LineStyle.hair), { all: true });
range.diagonalDown(new spreadNS.LineBorder('purple', spreadNS.LineStyle.dotted));
range = sheet.getRange(11, 7, 2, 2);
range.setBorder(new spreadNS.LineBorder('orange', spreadNS.LineStyle.mediumDashed), { all: true });
range.diagonalUp(new spreadNS.LineBorder('plum', spreadNS.LineStyle.double));
range.diagonalDown(new spreadNS.LineBorder('brown', spreadNS.LineStyle.thick));
range = sheet.getRange(11, 10, 2, 2);
range.setBorder(new spreadNS.LineBorder('orange', spreadNS.LineStyle.dashDot), { all: true });
range = sheet.getRange(17, 1, 2, 5);
range.setBorder(lineBorder1, { outline: true });
range = sheet.getRange(17, 1, 2, 2);
range.setBorder(new spreadNS.LineBorder('brown', spreadNS.LineStyle.slantedDashDot), { inside: true });
range = sheet.getRange(17, 4, 2, 2);
range.setBorder(new spreadNS.LineBorder('brown', spreadNS.LineStyle.mediumDashed), { inside: true });
range = sheet.getRange(16, 7, 7, 4);
range.setBorder(new spreadNS.LineBorder('plum', spreadNS.LineStyle.thick), {
left: true,
bottom: true
});
range = sheet.getRange(15, 8, 7, 4);
range.setBorder(new spreadNS.LineBorder('royalblue', spreadNS.LineStyle.slantedDashDot), {
top: true,
right: true
});
range = sheet.getRange(16, 8, 6, 3);
range.setBorder(new spreadNS.LineBorder('tomato', spreadNS.LineStyle.dashDot), {
left: true,
bottom: true
});
range = sheet.getRange(16, 8, 6, 3);
range.setBorder(new spreadNS.LineBorder('palegreen', spreadNS.LineStyle.mediumDashed), {
top: true,
right: true
});
range = sheet.getRange(16, 9, 5, 2);
range.setBorder(new spreadNS.LineBorder('violet', spreadNS.LineStyle.dotted), {
left: true,
bottom: true
});
range = sheet.getRange(17, 8, 5, 2);
range.setBorder(new spreadNS.LineBorder('skyblue', spreadNS.LineStyle.hair), {
top: true,
right: true
});
sheet.addSpan(17, 9, 2, 1);
range = sheet.getRange(17, 9, 2, 1);
range.setBorder(new spreadNS.LineBorder('purple', spreadNS.LineStyle.thin), { all: true });
sheet.setArray(1, 3, [
[ 'Gender', 'Phone Number', 'Address' ],
[ 'woman', '021-432668', 'Chester Road' ],
[ 'man', '021-432238', 'Gertt Road' ],
[ 'man', '021-432533', 'Jnyliner Road' ],
[ 'man', '021-432125', 'Approach Road' ]
]);
let style = new GC.Spread.Sheets.Style();
style.wordWrap = true;
style.vAlign = GC.Spread.Sheets.VerticalAlign.center;
sheet.setStyle(1, 2, style, 3);
sheet.setText(1, 2, ' Info Name', spreadNS.SheetArea.viewport);
let cell = sheet.getCell(1, 2);
cell.diagonalDown(new spreadNS.LineBorder('purple', spreadNS.LineStyle.dotted));
sheet.setStyle(1, 3, style, GC.Spread.Sheets.SheetArea.viewport);
sheet.setStyle(1, 4, style, GC.Spread.Sheets.SheetArea.viewport);
sheet.setStyle(1, 5, style, GC.Spread.Sheets.SheetArea.viewport);
sheet.setText(2, 2, 'John', spreadNS.SheetArea.viewport);
sheet.setText(3, 2, 'linda', spreadNS.SheetArea.viewport);
sheet.setText(4, 2, 'henry', spreadNS.SheetArea.viewport);
sheet.setText(5, 2, 'smith', spreadNS.SheetArea.viewport);
sheet.setRowHeight(1, 30);
sheet.setColumnWidth(4, 120);
sheet.setColumnWidth(5, 120);
range = sheet.getRange(1, 2, 5, 4);
range.setBorder(new spreadNS.LineBorder('black', spreadNS.LineStyle.thin), { all: true });
sheet.resumePaint();
}
initSheetAreaSheet() {
let sheet = this.spread.getSheet(1);
sheet.suspendPaint();
sheet.name('SheetAreaOffset');
let data = sheetAreaJSON;
sheet.fromJSON(data);
sheet.options.colHeaderVisible = false;
sheet.options.rowHeaderVisible = false;
sheet.options.sheetAreaOffset = {
left: 2,
top: 2
};
let range = sheet.getRange(0, 0, 3, 10);
range.setBorder(new spreadNS.LineBorder('black', spreadNS.LineStyle.double), {
left: true,
bottom: true,
top: true,
right: true
});
sheet.resumePaint();
this.headerVisible = sheet.options.colHeaderVisible && sheet.options.rowHeaderVisible;
this.left = sheet.options.sheetAreaOffset.left;
this.top = sheet.options.sheetAreaOffset.top;
}
setGridline ($event: any) {
let sheet = this.spread.getActiveSheet();
sheet.suspendPaint();
sheet.options.gridline.showHorizontalGridline = $event.target.checked;
sheet.options.gridline.showVerticalGridline = $event.target.checked;
sheet.resumePaint();
}
setHeaderVisible ($event: any) {
let sheet = this.spread.getActiveSheet();
sheet.options.rowHeaderVisible = $event.target.checked;
sheet.options.colHeaderVisible = $event.target.checked;
}
setOffset (position: any) {
let sheet = this.spread.getActiveSheet();
let left = position.left,
top = position.top;
sheet.options.sheetAreaOffset = {
left: parseInt(left, 10),
top: parseInt(top, 10)
}
}
}
@NgModule({
imports: [BrowserModule, SpreadSheetsModule, FormsModule],
declarations: [AppComponent],
exports: [AppComponent],
bootstrap: [AppComponent]
})
export class AppModule {}
enableProdMode();
// Bootstrap application with hash style navigation and global services.
platformBrowserDynamic().bootstrapModule(AppModule);
<!doctype html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/angular/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<script src="$DEMOROOT$/spread/source/data/sheetAreaData.js" type="text/javascript"></script>
<!-- Polyfills -->
<script src="$DEMOROOT$/en/angular/node_modules/core-js/client/shim.min.js"></script>
<script src="$DEMOROOT$/en/angular/node_modules/zone.js/fesm2015/zone.min.js"></script>
<!-- SystemJS -->
<script src="$DEMOROOT$/en/angular/node_modules/systemjs/dist/system.js"></script>
<script src="systemjs.config.js"></script>
<script>
// workaround to load 'rxjs/operators' from the rxjs bundle
System.import('rxjs').then(function (m) {
System.import('@angular/compiler');
System.set(SystemJS.resolveSync('rxjs/operators'), System.newModule(m.operators));
System.import('$DEMOROOT$/en/lib/angular/license.ts');
System.import('./src/app.component');
});
</script>
</head>
<body>
<app-component></app-component>
</body>
</html>
<div class="sample-tutorial">
<gc-spread-sheets [hostStyle]="hostStyle" (workbookInitialized)="initSpread($event)">
</gc-spread-sheets>
<div class="options-container" *ngIf="isGridLinePanel">
<div class="options-row">
<input type="checkbox" id="showGridLineCheckBox" [checked]="showGridLine" (change)="setGridline($event)"/>
<label for="showGridLineCheckBox">ShowGridLine</label>
</div>
</div>
<div class="options-container" *ngIf="!isGridLinePanel">
<div class="options-row">
<input type="checkbox" id="headerVisible" [checked]="headerVisible" (change)="setHeaderVisible($event)"/>
<label htmlFor="headerVisible">HeaderVisible</label>
</div>
<div class="options-row">
<label htmlFor="left">left:</label>
<input type="number" id="left" [(ngModel)]="left" [value]="left|number"/>
</div>
<div class="options-row">
<label htmlFor="top">top:</label>
<input type="number" id="top" [(ngModel)]="top" [value]="top|number"/>
</div>
<div class="options-row">
<input type="button" value="Set Sheet Area Offset" (click)="setOffset({left:left, top:top})"/>
</div>
</div>
</div>
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.options-container {
float: right;
width: 280px;
padding: 12px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
overflow: auto;
}
.options-row {
font-size: 14px;
padding: 5px;
margin-top: 10px;
}
input {
display: inline-block;
}
input[type="text"] {
width: 200px;
}
label {
width: 40px;
display: inline-block;
margin-bottom: 6px;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}
(function (global) {
System.config({
transpiler: 'ts',
typescriptOptions: {
tsconfig: true
},
meta: {
'typescript': {
"exports": "ts"
},
'*.css': { loader: 'css' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/',
'cdn:': 'https://cdn.mescius.io/demoapps/packages/spreadjs/19.1.0-master-2026-05-10-2130/'
},
// map tells the System loader where to look for things
map: {
'core-js': 'npm:core-js/client/shim.min.js',
'zone': 'npm:zone.js/fesm2015/zone.min.js',
'rxjs': 'npm:rxjs/dist/bundles/rxjs.umd.min.js',
'@angular/core': 'npm:@angular/core/fesm2022',
'@angular/common': 'npm:@angular/common/fesm2022/common.mjs',
'@angular/compiler': 'npm:@angular/compiler/fesm2022/compiler.mjs',
'@angular/platform-browser': 'npm:@angular/platform-browser/fesm2022/platform-browser.mjs',
'@angular/platform-browser-dynamic': 'npm:@angular/platform-browser-dynamic/fesm2022/platform-browser-dynamic.mjs',
'@angular/common/http': 'npm:@angular/common/fesm2022/http.mjs',
'@angular/router': 'npm:@angular/router/fesm2022/router.mjs',
'@angular/forms': 'npm:@angular/forms/fesm2022/forms.mjs',
'jszip': 'npm:jszip/dist/jszip.min.js',
'typescript': 'npm:typescript/lib/typescript.js',
'ts': './plugin.js',
'tslib':'npm:tslib/tslib.js',
'css': 'npm:systemjs-plugin-css/css.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js',
'@mescius/spread-sheets': 'cdn:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-angular': 'cdn:@mescius/spread-sheets-angular/fesm2020/mescius-spread-sheets-angular.mjs',
'@grapecity/jsob-test-dependency-package/react-components': 'npm:@grapecity/jsob-test-dependency-package/react-components/index.js'
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'ts'
},
rxjs: {
defaultExtension: 'js'
},
"node_modules": {
defaultExtension: 'js'
},
"node_modules/@angular": {
defaultExtension: 'mjs'
},
"@mescius/spread-sheets-angular": {
defaultExtension: 'mjs'
},
'@angular/core': {
defaultExtension: 'mjs',
main: 'core.mjs'
}
}
});
})(this);

Spread provides several types of line styles to help you customize the sheet's border line and grid lines, such as thin, dotted, double, and so on. For example, the following lines change the left and right border lines of the indicated range to the dotted line style.
Spread provides two kinds of diagonal border line. The diagonal border line includes diagonal down and diagonal up.
diagonalDown
diagonalUp
For example,The following set the diagonal border line for cells
You can add or remove gridlines or set the color with the following code:
You can set the option SheetAreaOffset to move the whole sheet rendering area have some offset from the host left/top point.There will be enough space to show all things (just like left/top border and left/top selection) perfectly.
The sheetAreaOffset default value is {left:0,top:0}.
import * as React from 'react';
import { createRoot } from 'react-dom/client';
import './styles.css';
import { AppFunc } from './app-func';
import { App } from './app-class';
// 1. Functional Component sample
createRoot(document.getElementById('app')).render(<AppFunc />);
// 2. Class Component sample
// createRoot(document.getElementById('app')).render(<App />);
import * as React from 'react';
import { SpreadSheets, Worksheet } from '@mescius/spread-sheets-react';
import GC from '@mescius/spread-sheets';
import './styles.css';
const useState = React.useState, spreadNS = GC.Spread.Sheets, SheetArea = spreadNS.SheetArea;
export function AppFunc() {
const [state, setState] = useState({ isGridLinePanel: true });
const [spread, setSpread] = useState(null);
const initSpread = (spread) => {
setSpread(spread);
spread.addSheet(1);
initSheetBorderAndGridLine(spread);
initSheetAreaSheet(spread);
let gridlineSheet = spread.getSheet(0);
spread.bind(GC.Spread.Sheets.Events.ActiveSheetChanged, function (e, args) {
let isGridLinePanel;
if (args.newSheet === gridlineSheet) {
isGridLinePanel = true;
} else {
isGridLinePanel = false;
}
setState({ isGridLinePanel: isGridLinePanel });
});
}
const initSheetBorderAndGridLine = (spread) => {
let sheet = spread.getSheet(0);
sheet.suspendPaint();
sheet.options.gridline.showHorizontalGridline = false;
sheet.options.gridline.showVerticalGridline = false;
let lineBorder1 = new spreadNS.LineBorder('blue', spreadNS.LineStyle.thin);
let range = sheet.getRange(7, 1, 2, 2);
range.setBorder(lineBorder1, { outline: true });
range.borderLeft(new spreadNS.LineBorder('red', spreadNS.LineStyle.double));
range = sheet.getRange(7, 4, 2, 2);
range.setBorder(lineBorder1, { outline: true });
range.borderTop(new spreadNS.LineBorder('green', spreadNS.LineStyle.medium));
range = sheet.getRange(7, 7, 2, 2);
range.setBorder(lineBorder1, { outline: true });
range.borderRight(new spreadNS.LineBorder('black', spreadNS.LineStyle.dashed));
range = sheet.getRange(7, 10, 2, 2);
range.setBorder(lineBorder1, { outline: true });
range.borderBottom(new spreadNS.LineBorder('purple', spreadNS.LineStyle.dotted));
range = sheet.getRange(11, 1, 2, 2);
range.setBorder(new spreadNS.LineBorder('orange', spreadNS.LineStyle.thick), { all: true });
range.diagonalUp(new spreadNS.LineBorder('orange', spreadNS.LineStyle.thin));
range = sheet.getRange(11, 4, 2, 2);
range.setBorder(new spreadNS.LineBorder('orange', spreadNS.LineStyle.hair), { all: true });
range.diagonalDown(new spreadNS.LineBorder('purple', spreadNS.LineStyle.dotted));
range = sheet.getRange(11, 7, 2, 2);
range.setBorder(new spreadNS.LineBorder('orange', spreadNS.LineStyle.mediumDashed), { all: true });
range.diagonalUp(new spreadNS.LineBorder('plum', spreadNS.LineStyle.double));
range.diagonalDown(new spreadNS.LineBorder('brown', spreadNS.LineStyle.thick));
range = sheet.getRange(11, 10, 2, 2);
range.setBorder(new spreadNS.LineBorder('orange', spreadNS.LineStyle.dashDot), { all: true });
range = sheet.getRange(17, 1, 2, 5);
range.setBorder(lineBorder1, { outline: true });
range = sheet.getRange(17, 1, 2, 2);
range.setBorder(new spreadNS.LineBorder('brown', spreadNS.LineStyle.slantedDashDot), { inside: true });
range = sheet.getRange(17, 4, 2, 2);
range.setBorder(new spreadNS.LineBorder('brown', spreadNS.LineStyle.mediumDashed), { inside: true });
range = sheet.getRange(16, 7, 7, 4);
range.setBorder(new spreadNS.LineBorder('plum', spreadNS.LineStyle.thick), {
left: true,
bottom: true
});
range = sheet.getRange(15, 8, 7, 4);
range.setBorder(new spreadNS.LineBorder('royalblue', spreadNS.LineStyle.slantedDashDot), {
top: true,
right: true
});
range = sheet.getRange(16, 8, 6, 3);
range.setBorder(new spreadNS.LineBorder('tomato', spreadNS.LineStyle.dashDot), {
left: true,
bottom: true
});
range = sheet.getRange(16, 8, 6, 3);
range.setBorder(new spreadNS.LineBorder('palegreen', spreadNS.LineStyle.mediumDashed), {
top: true,
right: true
});
range = sheet.getRange(16, 9, 5, 2);
range.setBorder(new spreadNS.LineBorder('violet', spreadNS.LineStyle.dotted), {
left: true,
bottom: true
});
range = sheet.getRange(17, 8, 5, 2);
range.setBorder(new spreadNS.LineBorder('skyblue', spreadNS.LineStyle.hair), {
top: true,
right: true
});
sheet.addSpan(17, 9, 2, 1);
range = sheet.getRange(17, 9, 2, 1);
range.setBorder(new spreadNS.LineBorder('purple', spreadNS.LineStyle.thin), { all: true });
sheet.setArray(1, 3, [
['Gender', 'Phone Number', 'Address'],
['woman', '021-432668', 'Chester Road'],
['man', '021-432238', 'Gertt Road'],
['man', '021-432533', 'Jnyliner Road'],
['man', '021-432125', 'Approach Road']
]);
let style = new GC.Spread.Sheets.Style();
style.wordWrap = true;
style.vAlign = GC.Spread.Sheets.VerticalAlign.center;
sheet.setStyle(1, 2, style, 3);
sheet.setText(1, 2, ' Info Name', spreadNS.SheetArea.viewport);
let cell = sheet.getCell(1, 2);
cell.diagonalDown(new spreadNS.LineBorder('purple', spreadNS.LineStyle.dotted));
sheet.setStyle(1, 3, style, GC.Spread.Sheets.SheetArea.viewport);
sheet.setStyle(1, 4, style, GC.Spread.Sheets.SheetArea.viewport);
sheet.setStyle(1, 5, style, GC.Spread.Sheets.SheetArea.viewport);
sheet.setText(2, 2, 'John', spreadNS.SheetArea.viewport);
sheet.setText(3, 2, 'linda', spreadNS.SheetArea.viewport);
sheet.setText(4, 2, 'henry', spreadNS.SheetArea.viewport);
sheet.setText(5, 2, 'smith', spreadNS.SheetArea.viewport);
sheet.setRowHeight(1, 30);
sheet.setColumnWidth(4, 120);
sheet.setColumnWidth(5, 120);
range = sheet.getRange(1, 2, 5, 4);
range.setBorder(new spreadNS.LineBorder('black', spreadNS.LineStyle.thin), { all: true });
sheet.resumePaint();
}
const initSheetAreaSheet = (spread) => {
let sheet = spread.getSheet(1);
sheet.suspendPaint();
sheet.name('SheetAreaOffset');
let data = sheetAreaJSON;
sheet.fromJSON(data);
sheet.options.colHeaderVisible = false;
sheet.options.rowHeaderVisible = false;
sheet.options.sheetAreaOffset = {
left: 2,
top: 2
};
let range = sheet.getRange(0, 0, 3, 10);
range.setBorder(new spreadNS.LineBorder('black', spreadNS.LineStyle.double), {
left: true,
bottom: true,
top: true,
right: true
});
sheet.resumePaint();
}
const setGridline = ($event) => {
let sheet = spread.getActiveSheet();
sheet.suspendPaint();
sheet.options.gridline.showHorizontalGridline = $event.target.checked;
sheet.options.gridline.showVerticalGridline = $event.target.checked;
sheet.resumePaint();
}
const setHeaderVisible = ($event) => {
let sheet = spread.getActiveSheet();
sheet.options.rowHeaderVisible = $event.target.checked;
sheet.options.colHeaderVisible = $event.target.checked;
}
const setOffset = (position) => {
let sheet = spread.getActiveSheet();
let left = position.left,
top = position.top;
sheet.options.sheetAreaOffset = {
left: parseInt(left, 10),
top: parseInt(top, 10)
}
}
return (
<div class="sample-tutorial">
<div class="sample-spreadsheets">
<SpreadSheets workbookInitialized={spread => initSpread(spread)}>
<Worksheet>
</Worksheet>
</SpreadSheets>
</div>
<Panel
isGridLinePanel={state.isGridLinePanel}
setGridline={(e) => setGridline(e)}
setHeaderVisible={(e) => setHeaderVisible(e)}
setOffset={(position) => setOffset(position)}
></Panel>
</div>
);
}
function TextInput(props) {
const [value, setValue] = useState(props.value);
return (
<input type="number" value={value} onChange={(e) => {
setValue(e.target.value);
props.onChange(e)
}} />
);
}
function CheckBoxInput(props) {
const [checked, setChecked] = useState(props.checked);
return (
<input type="checkbox" id={props.id} checked={checked} onChange={(e) => {
setChecked(e.target.checked);
props.onChange(e);
}} />
);
}
function Panel(props) {
const [left, setLeft] = useState("");
const [top, setTop] = useState("");
if (props.isGridLinePanel) {
return (<div className="options-container">
<div className="options-row">
<CheckBoxInput id="showGridLine" checked={false} onChange={props.setGridline}></CheckBoxInput>
<label htmlFor="showGridLine">ShowGridLine</label>
</div>
</div>);
} else {
return (<div className="options-container">
<div className="options-row">
<CheckBoxInput id="headerVisible" checked={false} onChange={props.setHeaderVisible}></CheckBoxInput>
<label htmlFor="headerVisible">HeaderVisible</label>
</div>
<div className="options-row">
<label htmlFor="left">left:</label>
<TextInput id="left" value={left} onChange={(e) => setLeft(e.target.value)}></TextInput>
</div>
<div className="options-row">
<label htmlFor="top">top:</label>
<TextInput id="top" value={top} onChange={(e) => setTop(e.target.value)}></TextInput>
</div>
<div className="options-row">
<input type="button" value="Set Sheet Area Offset" onClick={() => props.setOffset({ left, top })} />
</div>
</div>);
}
}
import * as React from 'react';
import {SpreadSheets, Worksheet} from '@mescius/spread-sheets-react';
import GC from '@mescius/spread-sheets';
import './styles.css';
const Component = React.Component, useState = React.useState, spreadNS = GC.Spread.Sheets, SheetArea = spreadNS.SheetArea;
export class App extends Component {
constructor(props) {
super(props);
this.spread = null;
this.state = {
isGridLinePanel: true
};
}
initSpread(spread) {
let self = this;
self.spread = spread;
spread.addSheet(1);
this.initSheetBorderAndGridLine();
this.initSheetAreaSheet();
let gridlineSheet = spread.getSheet(0);
spread.bind(GC.Spread.Sheets.Events.ActiveSheetChanged, function(e, args) {
let isGridLinePanel;
if (args.newSheet === gridlineSheet) {
isGridLinePanel = true;
} else {
isGridLinePanel = false;
}
self.setState({isGridLinePanel: isGridLinePanel});
});
}
initSheetBorderAndGridLine() {
let spread = this.spread;
let sheet = spread.getSheet(0);
sheet.suspendPaint();
sheet.options.gridline.showHorizontalGridline = false;
sheet.options.gridline.showVerticalGridline = false;
let lineBorder1 = new spreadNS.LineBorder('blue', spreadNS.LineStyle.thin);
let range = sheet.getRange(7, 1, 2, 2);
range.setBorder(lineBorder1, { outline: true });
range.borderLeft(new spreadNS.LineBorder('red', spreadNS.LineStyle.double));
range = sheet.getRange(7, 4, 2, 2);
range.setBorder(lineBorder1, { outline: true });
range.borderTop(new spreadNS.LineBorder('green', spreadNS.LineStyle.medium));
range = sheet.getRange(7, 7, 2, 2);
range.setBorder(lineBorder1, { outline: true });
range.borderRight(new spreadNS.LineBorder('black', spreadNS.LineStyle.dashed));
range = sheet.getRange(7, 10, 2, 2);
range.setBorder(lineBorder1, { outline: true });
range.borderBottom(new spreadNS.LineBorder('purple', spreadNS.LineStyle.dotted));
range = sheet.getRange(11, 1, 2, 2);
range.setBorder(new spreadNS.LineBorder('orange', spreadNS.LineStyle.thick), { all: true });
range.diagonalUp(new spreadNS.LineBorder('orange', spreadNS.LineStyle.thin));
range = sheet.getRange(11, 4, 2, 2);
range.setBorder(new spreadNS.LineBorder('orange', spreadNS.LineStyle.hair), { all: true });
range.diagonalDown(new spreadNS.LineBorder('purple', spreadNS.LineStyle.dotted));
range = sheet.getRange(11, 7, 2, 2);
range.setBorder(new spreadNS.LineBorder('orange', spreadNS.LineStyle.mediumDashed), { all: true });
range.diagonalUp(new spreadNS.LineBorder('plum', spreadNS.LineStyle.double));
range.diagonalDown(new spreadNS.LineBorder('brown', spreadNS.LineStyle.thick));
range = sheet.getRange(11, 10, 2, 2);
range.setBorder(new spreadNS.LineBorder('orange', spreadNS.LineStyle.dashDot), { all: true });
range = sheet.getRange(17, 1, 2, 5);
range.setBorder(lineBorder1, { outline: true });
range = sheet.getRange(17, 1, 2, 2);
range.setBorder(new spreadNS.LineBorder('brown', spreadNS.LineStyle.slantedDashDot), { inside: true });
range = sheet.getRange(17, 4, 2, 2);
range.setBorder(new spreadNS.LineBorder('brown', spreadNS.LineStyle.mediumDashed), { inside: true });
range = sheet.getRange(16, 7, 7, 4);
range.setBorder(new spreadNS.LineBorder('plum', spreadNS.LineStyle.thick), {
left: true,
bottom: true
});
range = sheet.getRange(15, 8, 7, 4);
range.setBorder(new spreadNS.LineBorder('royalblue', spreadNS.LineStyle.slantedDashDot), {
top: true,
right: true
});
range = sheet.getRange(16, 8, 6, 3);
range.setBorder(new spreadNS.LineBorder('tomato', spreadNS.LineStyle.dashDot), {
left: true,
bottom: true
});
range = sheet.getRange(16, 8, 6, 3);
range.setBorder(new spreadNS.LineBorder('palegreen', spreadNS.LineStyle.mediumDashed), {
top: true,
right: true
});
range = sheet.getRange(16, 9, 5, 2);
range.setBorder(new spreadNS.LineBorder('violet', spreadNS.LineStyle.dotted), {
left: true,
bottom: true
});
range = sheet.getRange(17, 8, 5, 2);
range.setBorder(new spreadNS.LineBorder('skyblue', spreadNS.LineStyle.hair), {
top: true,
right: true
});
sheet.addSpan(17, 9, 2, 1);
range = sheet.getRange(17, 9, 2, 1);
range.setBorder(new spreadNS.LineBorder('purple', spreadNS.LineStyle.thin), { all: true });
sheet.setArray(1, 3, [
[ 'Gender', 'Phone Number', 'Address' ],
[ 'woman', '021-432668', 'Chester Road' ],
[ 'man', '021-432238', 'Gertt Road' ],
[ 'man', '021-432533', 'Jnyliner Road' ],
[ 'man', '021-432125', 'Approach Road' ]
]);
let style = new GC.Spread.Sheets.Style();
style.wordWrap = true;
style.vAlign = GC.Spread.Sheets.VerticalAlign.center;
sheet.setStyle(1, 2, style, 3);
sheet.setText(1, 2, ' Info Name', spreadNS.SheetArea.viewport);
let cell = sheet.getCell(1, 2);
cell.diagonalDown(new spreadNS.LineBorder('purple', spreadNS.LineStyle.dotted));
sheet.setStyle(1, 3, style, GC.Spread.Sheets.SheetArea.viewport);
sheet.setStyle(1, 4, style, GC.Spread.Sheets.SheetArea.viewport);
sheet.setStyle(1, 5, style, GC.Spread.Sheets.SheetArea.viewport);
sheet.setText(2, 2, 'John', spreadNS.SheetArea.viewport);
sheet.setText(3, 2, 'linda', spreadNS.SheetArea.viewport);
sheet.setText(4, 2, 'henry', spreadNS.SheetArea.viewport);
sheet.setText(5, 2, 'smith', spreadNS.SheetArea.viewport);
sheet.setRowHeight(1, 30);
sheet.setColumnWidth(4, 120);
sheet.setColumnWidth(5, 120);
range = sheet.getRange(1, 2, 5, 4);
range.setBorder(new spreadNS.LineBorder('black', spreadNS.LineStyle.thin), { all: true });
sheet.resumePaint();
}
initSheetAreaSheet() {
let sheet = this.spread.getSheet(1);
sheet.suspendPaint();
sheet.name('SheetAreaOffset');
let data = sheetAreaJSON;
sheet.fromJSON(data);
sheet.options.colHeaderVisible = false;
sheet.options.rowHeaderVisible = false;
sheet.options.sheetAreaOffset = {
left: 2,
top: 2
};
let range = sheet.getRange(0, 0, 3, 10);
range.setBorder(new spreadNS.LineBorder('black', spreadNS.LineStyle.double), {
left: true,
bottom: true,
top: true,
right: true
});
sheet.resumePaint();
}
setGridline ($event) {
let sheet = this.spread.getActiveSheet();
sheet.suspendPaint();
sheet.options.gridline.showHorizontalGridline = $event.target.checked;
sheet.options.gridline.showVerticalGridline = $event.target.checked;
sheet.resumePaint();
}
setHeaderVisible ($event) {
let sheet = this.spread.getActiveSheet();
sheet.options.rowHeaderVisible = $event.target.checked;
sheet.options.colHeaderVisible = $event.target.checked;
}
setOffset (position) {
let sheet = this.spread.getActiveSheet();
let left = position.left,
top = position.top;
sheet.options.sheetAreaOffset = {
left: parseInt(left, 10),
top: parseInt(top, 10)
}
}
render() {
return (
<div class="sample-tutorial">
<div class="sample-spreadsheets">
<SpreadSheets workbookInitialized={spread => this.initSpread(spread)}>
<Worksheet>
</Worksheet>
</SpreadSheets>
</div>
<Panel
isGridLinePanel={this.state.isGridLinePanel}
setGridline={(e) => this.setGridline(e)}
setHeaderVisible={(e) => this.setHeaderVisible(e)}
setOffset={(position) => this.setOffset (position)}
></Panel>
</div>
);
}
}
function TextInput(props) {
const [value, setValue] = useState(props.value);
return (
<input type="number" value={value} onChange={(e) => {
setValue(e.target.value);
props.onChange(e)
}}/>
);
}
function CheckBoxInput(props) {
const [checked, setChecked] = useState(props.checked);
return (
<input type="checkbox" id={props.id} checked={checked} onChange={(e) => {
setChecked(e.target.checked);
props.onChange(e);
}}/>
);
}
class Panel extends Component {
constructor(props) {
super(props);
this.left = "";
this.top = "";
}
render () {
let props = this.props, panel;
if (props.isGridLinePanel) {
panel = (
<div className="options-container">
<div className="options-row">
<CheckBoxInput id="showGridLine" checked={false} onChange={props.setGridline}></CheckBoxInput>
<label htmlFor="showGridLine">ShowGridLine</label>
</div>
</div>
);
} else {
panel = (
<div className="options-container">
<div className="options-row">
<CheckBoxInput id="headerVisible" checked={false} onChange={props.setHeaderVisible}></CheckBoxInput>
<label htmlFor="headerVisible">HeaderVisible</label>
</div>
<div className="options-row">
<label htmlFor="left">left:</label>
<TextInput id="left" value={this.left} onChange={(e) => {this.left = e.target.value;}}></TextInput>
</div>
<div className="options-row">
<label htmlFor="top">top:</label>
<TextInput id="top" value={this.top} onChange={(e) => {this.top = e.target.value;}}></TextInput>
</div>
<div className="options-row">
<input type="button" value="Set Sheet Area Offset" onClick={() => {let position = {left:this.left, top:this.top};props.setOffset(position);}}/>
</div>
</div>
);
}
return panel;
}
}
<!doctype html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/react/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<script src="$DEMOROOT$/spread/source/data/sheetAreaData.js" type="text/javascript"></script>
<!-- SystemJS -->
<script src="$DEMOROOT$/en/react/node_modules/systemjs/dist/system.src.js"></script>
<script src="systemjs.config.js"></script>
<script>
System.import('$DEMOROOT$/en/lib/react/license.js').then(function () {
System.import('./src/app');
});
</script>
</head>
<body>
<div id="app"></div>
</body>
</html>
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.sample-spreadsheets {
width: calc(100% - 280px);
height: 100%;
overflow: hidden;
float: left;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}
#app {
height: 100%;
}
.options-container {
float: right;
width: 280px;
padding: 12px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
overflow: auto;
}
.options-row {
font-size: 14px;
padding: 5px;
margin-top: 10px;
}
input {
display: inline-block;
}
input[type="text"] {
width: 200px;
}
label {
width: 40px;
display: inline-block;
margin-bottom: 6px;
}
(function (global) {
System.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true,
react: true
},
meta: {
'*.css': { loader: 'css' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
// map tells the System loader where to look for things
map: {
'@mescius/spread-sheets': 'npm:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-react': 'npm:@mescius/spread-sheets-react/index.js',
'@grapecity/jsob-test-dependency-package/react-components': 'npm:@grapecity/jsob-test-dependency-package/react-components/index.js',
'react': 'npm:react/cjs/react.production.js',
'react-dom': 'npm:react-dom/cjs/react-dom.production.js',
'react-dom/client': 'npm:react-dom/cjs/react-dom-client.production.js',
'scheduler': 'npm:scheduler/cjs/scheduler.production.js',
'css': 'npm:systemjs-plugin-css/css.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js'
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'jsx'
},
"node_modules": {
defaultExtension: 'js'
},
}
});
})(this);

Spread provides several types of line styles to help you customize the sheet's border line and grid lines, such as thin, dotted, double, and so on. For example, the following lines change the left and right border lines of the indicated range to the dotted line style.
Spread provides two kinds of diagonal border line. The diagonal border line includes diagonal down and diagonal up.
diagonalDown
diagonalUp
For example,The following set the diagonal border line for cells
You can add or remove gridlines or set the color with the following code:
You can set the option SheetAreaOffset to move the whole sheet rendering area have some offset from the host left/top point.There will be enough space to show all things (just like left/top border and left/top selection) perfectly.
The sheetAreaOffset default value is {left:0,top:0}.
<template>
<div class="sample-tutorial">
<gc-spread-sheets class="sample-spreadsheets" @workbookInitialized="initSpread">
<gc-worksheet>
</gc-worksheet>
</gc-spread-sheets>
<div class="options-container" v-if="isGridLinePanel">
<div class="options-row">
<input type="checkbox" id="showGridLineCheckBox" v-model="showGridLine" />
<label for="showGridLineCheckBox">ShowGridLine</label>
</div>
</div>
<div class="options-container" v-if="!isGridLinePanel">
<div class="options-row">
<input type="checkbox" id="headerVisible" v-model="headerVisible" />
<label for="headerVisible">HeaderVisible</label>
</div>
<div class="options-row">
<label for="left">left:</label>
<input type="number" id="left" v-model="left" />
</div>
<div class="options-row">
<label for="top">top:</label>
<input type="number" id="top" v-model="top" />
</div>
<div class="options-row">
<input type="button" value="Set Sheet Area Offset" @click="setOffset()" />
</div>
</div>
</div>
</template>
<script setup>
import { ref, watch } from "vue";
import "@mescius/spread-sheets-vue";
import GC from '@mescius/spread-sheets';
let spreadNS = GC.Spread.Sheets;
const spreadRef = ref(null);
const showGridLine = ref(false);
const headerVisible = ref(false);
const left = ref("2");
const top = ref("2");
const isGridLinePanel = ref(true);
watch(showGridLine, (value) => {
let sheet = spreadRef.value.getActiveSheet();
sheet.suspendPaint();
sheet.options.gridline.showHorizontalGridline = value;
sheet.options.gridline.showVerticalGridline = value;
sheet.resumePaint();
});
watch(headerVisible, (value) => {
let sheet = spreadRef.value.getActiveSheet();
sheet.options.rowHeaderVisible = value;
sheet.options.colHeaderVisible = value;
});
let initSpread = function (spread) {
spreadRef.value = spread;
spread.addSheet(1);
initSheetBorderAndGridLine();
initSheetAreaSheet();
let gridlineSheet = spread.getSheet(0);
showGridLine.value = gridlineSheet.options.gridline.showHorizontalGridline && gridlineSheet.options.gridline.showVerticalGridline;
spread.bind(GC.Spread.Sheets.Events.ActiveSheetChanged, function (e, args) {
let isGridLinePanelValue;
if (args.newSheet === gridlineSheet) {
isGridLinePanelValue = true;
} else {
isGridLinePanelValue = false;
}
isGridLinePanel.value = isGridLinePanelValue;
});
}
function initSheetBorderAndGridLine() {
let spread = spreadRef.value;
let sheet = spread.getSheet(0);
sheet.suspendPaint();
sheet.options.gridline.showHorizontalGridline = false;
sheet.options.gridline.showVerticalGridline = false;
let lineBorder1 = new spreadNS.LineBorder('blue', spreadNS.LineStyle.thin);
let range = sheet.getRange(7, 1, 2, 2);
range.setBorder(lineBorder1, { outline: true });
range.borderLeft(new spreadNS.LineBorder('red', spreadNS.LineStyle.double));
range = sheet.getRange(7, 4, 2, 2);
range.setBorder(lineBorder1, { outline: true });
range.borderTop(new spreadNS.LineBorder('green', spreadNS.LineStyle.medium));
range = sheet.getRange(7, 7, 2, 2);
range.setBorder(lineBorder1, { outline: true });
range.borderRight(new spreadNS.LineBorder('black', spreadNS.LineStyle.dashed));
range = sheet.getRange(7, 10, 2, 2);
range.setBorder(lineBorder1, { outline: true });
range.borderBottom(new spreadNS.LineBorder('purple', spreadNS.LineStyle.dotted));
range = sheet.getRange(11, 1, 2, 2);
range.setBorder(new spreadNS.LineBorder('orange', spreadNS.LineStyle.thick), { all: true });
range.diagonalUp(new spreadNS.LineBorder('orange', spreadNS.LineStyle.thin));
range = sheet.getRange(11, 4, 2, 2);
range.setBorder(new spreadNS.LineBorder('orange', spreadNS.LineStyle.hair), { all: true });
range.diagonalDown(new spreadNS.LineBorder('purple', spreadNS.LineStyle.dotted));
range = sheet.getRange(11, 7, 2, 2);
range.setBorder(new spreadNS.LineBorder('orange', spreadNS.LineStyle.mediumDashed), { all: true });
range.diagonalUp(new spreadNS.LineBorder('plum', spreadNS.LineStyle.double));
range.diagonalDown(new spreadNS.LineBorder('brown', spreadNS.LineStyle.thick));
range = sheet.getRange(11, 10, 2, 2);
range.setBorder(new spreadNS.LineBorder('orange', spreadNS.LineStyle.dashDot), { all: true });
range = sheet.getRange(17, 1, 2, 5);
range.setBorder(lineBorder1, { outline: true });
range = sheet.getRange(17, 1, 2, 2);
range.setBorder(new spreadNS.LineBorder('brown', spreadNS.LineStyle.slantedDashDot), { inside: true });
range = sheet.getRange(17, 4, 2, 2);
range.setBorder(new spreadNS.LineBorder('brown', spreadNS.LineStyle.mediumDashed), { inside: true });
range = sheet.getRange(16, 7, 7, 4);
range.setBorder(new spreadNS.LineBorder('plum', spreadNS.LineStyle.thick), {
left: true,
bottom: true
});
range = sheet.getRange(15, 8, 7, 4);
range.setBorder(new spreadNS.LineBorder('royalblue', spreadNS.LineStyle.slantedDashDot), {
top: true,
right: true
});
range = sheet.getRange(16, 8, 6, 3);
range.setBorder(new spreadNS.LineBorder('tomato', spreadNS.LineStyle.dashDot), {
left: true,
bottom: true
});
range = sheet.getRange(16, 8, 6, 3);
range.setBorder(new spreadNS.LineBorder('palegreen', spreadNS.LineStyle.mediumDashed), {
top: true,
right: true
});
range = sheet.getRange(16, 9, 5, 2);
range.setBorder(new spreadNS.LineBorder('violet', spreadNS.LineStyle.dotted), {
left: true,
bottom: true
});
range = sheet.getRange(17, 8, 5, 2);
range.setBorder(new spreadNS.LineBorder('skyblue', spreadNS.LineStyle.hair), {
top: true,
right: true
});
sheet.addSpan(17, 9, 2, 1);
range = sheet.getRange(17, 9, 2, 1);
range.setBorder(new spreadNS.LineBorder('purple', spreadNS.LineStyle.thin), { all: true });
sheet.setArray(1, 3, [
['Gender', 'Phone Number', 'Address'],
['woman', '021-432668', 'Chester Road'],
['man', '021-432238', 'Gertt Road'],
['man', '021-432533', 'Jnyliner Road'],
['man', '021-432125', 'Approach Road']
]);
let style = new GC.Spread.Sheets.Style();
style.wordWrap = true;
style.vAlign = GC.Spread.Sheets.VerticalAlign.center;
sheet.setStyle(1, 2, style, 3);
sheet.setText(1, 2, ' Info Name', spreadNS.SheetArea.viewport);
let cell = sheet.getCell(1, 2);
cell.diagonalDown(new spreadNS.LineBorder('purple', spreadNS.LineStyle.dotted));
sheet.setStyle(1, 3, style, GC.Spread.Sheets.SheetArea.viewport);
sheet.setStyle(1, 4, style, GC.Spread.Sheets.SheetArea.viewport);
sheet.setStyle(1, 5, style, GC.Spread.Sheets.SheetArea.viewport);
sheet.setText(2, 2, 'John', spreadNS.SheetArea.viewport);
sheet.setText(3, 2, 'linda', spreadNS.SheetArea.viewport);
sheet.setText(4, 2, 'henry', spreadNS.SheetArea.viewport);
sheet.setText(5, 2, 'smith', spreadNS.SheetArea.viewport);
sheet.setRowHeight(1, 30);
sheet.setColumnWidth(4, 120);
sheet.setColumnWidth(5, 120);
range = sheet.getRange(1, 2, 5, 4);
range.setBorder(new spreadNS.LineBorder('black', spreadNS.LineStyle.thin), { all: true });
sheet.resumePaint();
}
function initSheetAreaSheet() {
let sheet = spreadRef.value.getSheet(1);
sheet.suspendPaint();
sheet.name('SheetAreaOffset');
let data = sheetAreaJSON;
sheet.fromJSON(data);
sheet.options.colHeaderVisible = false;
sheet.options.rowHeaderVisible = false;
sheet.options.sheetAreaOffset = {
left: 2,
top: 2
};
let range = sheet.getRange(0, 0, 3, 10);
range.setBorder(new spreadNS.LineBorder('black', spreadNS.LineStyle.double), {
left: true,
bottom: true,
top: true,
right: true
});
sheet.resumePaint();
headerVisible.value = sheet.options.colHeaderVisible && sheet.options.rowHeaderVisible;
left.value = sheet.options.sheetAreaOffset.left;
top.value = sheet.options.sheetAreaOffset.top;
}
function setOffset() {
let sheet = spreadRef.value.getActiveSheet();
let leftValue = left.value,
topValue = top.value;
sheet.options.sheetAreaOffset = {
left: parseInt(leftValue, 10),
top: parseInt(topValue, 10)
}
}
</script>
<style scoped>
#app {
height: 100%;
}
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.sample-spreadsheets {
width: calc(100% - 280px);
height: 100%;
overflow: hidden;
float: left;
}
.options-container {
float: right;
width: 280px;
padding: 12px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
overflow: auto;
}
.options-row {
font-size: 14px;
padding: 5px;
margin-top: 10px;
}
input {
display: inline-block;
}
input[type="text"] {
width: 160px;
}
label {
display: inline-block;
margin-bottom: 6px;
width: 200px;
}
select {
width: 120px;
height: 35px;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}
</style>
<!DOCTYPE html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<title>SpreadJS VUE</title>
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css"
href="$DEMOROOT$/en/vue3/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<script src="$DEMOROOT$/en/vue3/node_modules/systemjs/dist/system.src.js"></script>
<script src="./systemjs.config.js"></script>
<script src="./compiler.js" type="module"></script>
<script src="$DEMOROOT$/spread/source/data/sheetAreaData.js" type="text/javascript"></script>
<script>
var System = SystemJS;
System.import("./src/app.js");
System.import('$DEMOROOT$/en/lib/vue3/license.js');
</script>
</head>
<body>
<div id="app"></div>
</body>
</html>
(function (global) {
SystemJS.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
packageConfigPaths: [
'./node_modules/*/package.json',
"./node_modules/@mescius/*/package.json",
"./node_modules/@babel/*/package.json",
"./node_modules/@vue/*/package.json"
],
map: {
'vue': "npm:vue/dist/vue.esm-browser.js",
'tiny-emitter': 'npm:tiny-emitter/index.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
"systemjs-babel-build": "npm:systemjs-plugin-babel/systemjs-babel-browser.js",
'@mescius/spread-sheets': 'npm:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-resources-en': 'npm:@mescius/spread-sheets-resources-en/index.js',
'@mescius/spread-sheets-vue': 'npm:@mescius/spread-sheets-vue/index.js'
},
meta: {
'*.css': { loader: 'systemjs-plugin-css' },
'*.vue': { loader: "../plugin-vue/index.js" }
}
});
})(this);